module module_lastns
!
!*****************************************************************************!
!                                                                             !
!   Revision : 1.0         Author : J.Jansen        Date : 30 October 1997    !
!   Revision : 2.0         Author : J.Jansen        Date : 8 September 1998   !
!                                                                             !
!-----------------------------------------------------------------------------!
!                                                                             !
! Revision 1.0 is a module version                                            !
!                                                                             !
! VMS(AXP)/AIX(RS6000)/IRIX/OSF version                                       !
!                                                                             !
!*****************************************************************************!
!
  contains
  FUNCTION LASTNS(STRING,N)
!
    implicit none
!
    integer ( kind = 4 ) , optional :: n
    integer ( kind = 4 ) :: lastns , ilen , i
        CHARACTER*(*) STRING
!
        ilen = len( string )
        if ( present( n ) ) then
          ilen = min( n , ilen )
        end if
!
        DO 10 I= ileN,1,-1
        IF(STRING(I:I).NE.' ')THEN
          LASTNS=I
          RETURN
        ENDIF
10      CONTINUE
!
        LASTNS=0
      END function lastns
!
    end module module_lastns
!
program abac
!
!*****************************************************************************!
!                                                                             !
!               Author : J.Jansen           Date : 1 March 2007               !
!                                                                             !
!-----------------------------------------------------------------------------!
!                                                                             !
! Backup directory trees with conservation of aliasses                        !
!                                                                             !
! OpenVMS version                                                             !
!                                                                             !
!*****************************************************************************!
!
  use module_lastns
!
  integer ( kind = 4 ) :: iposs , iposd , len_source , len_dest , ipos1 , ipos2
  integer ( kind = 4 ) :: ipos3
  character ( len = 512 ) :: source , dest , line , source_up , line_up
  character ( len = 64 ) :: dev_source , dev_dest
!
! Get commandline arguments
  call getarg( 1 , source )
  call getarg( 2 , dest )
  len_source = lastns( source )
  len_dest = lastns( dest )
!
! Create alias file
  iposs = index( source , ':' )
  if ( iposs < 2 ) stop 'no source device'
  dev_source = source( 1:iposs-1 )
  iposd = index( dest , '...]' )
  if ( iposd < 2 ) stop 'dest syntax error'
  dev_dest = dest( 1:iposd-1 )
  call lib$spawn( 'dfu dir/alias/output=alias.txt ' // dev_source( 1:iposs ) )
!
! perform backup
  call lib$spawn( 'backup ' // source( 1:len_source ) // '*.* ' // dest( &
&   1:len_dest ) // '/noalias' )
!
! setup aliasses
  open( unit=37 , file='alias.txt' )
  source_up = source
  call upcase( source_up , len_source )
  50 read( 37 , '( a )' , end=51 ) line
  line_up = line
  call upcase( line_up , 512 ) 
  if ( index( line_up , source_up( iposs+1:len_source-4 ) ) > 0 ) then
    ipos1 = index( line_up , source_up( iposs+1:len_source-4 ) ) + len_source &
&     - iposs - 4
    ipos2 = index( line , ' ' ) - 1
    ipos3 = index( line_up( ipos2+1: ) , source_up( iposs+1:len_source-4 ) )
    if ( ipos3 > 0 ) then
      ipos3 = ipos3 + len_source - iposs - 4
      call lib$spawn( 'set file/enter=' // dev_dest( 1:iposd-1 ) // line( &
&       ipos1:ipos2 ) // ' ' // dev_dest( 1:iposd-1 ) // line( &
&       ipos3+ipos2: ) )
    end if
  end if
  goto 50
  51 close( 37 , status='delete' )
!
end
!
subroutine getarg( numpar , param )
!
!*******************************************************************************
!                                                                              *
!            Author : J.Jansen               Date : 3 May 1993                 *
!   Revision : 1.0          Author : J.Jansen      Date : 25 September 2000    !
!   Revision : 2.0          Author : J.Jansen      Date : 6 June 2002          !
!   Revision : 3.0          Author : J.Jansen      Date : 13 May 2003          !
!                                                                              *
!------------------------------------------------------------------------------*
!                                                                              *
! Subroutine to get command parameters                                         *
!                                                                              *
! VMS(VAX,AXP) version                                                         *
!                                                                              *
!------------------------------------------------------------------------------*
!                                                                              *
!    Parameter         Type                   Purpose                          *
!    numpar           integer      Number of parameters                        *
!    param            char*(*)     parameter value                             *
!    para_name        char*2       Parameter name                              *
!                                                                              *
!*******************************************************************************
!
        implicit none
!
        character*(*) param
        character ( len = 1024 ) string
        integer ( kind = 4 ) :: numpar , len_string , ipos , iend , i
!
      call lib$get_foreign( string , , len_string )
      if ( numpar == 0 ) then
        do while ( string( 1:1 ) == ' ' )
          string = string( 2: )
        end do
        ipos = index( string , ' ' )
        param = string( 1:ipos )
      else
        ipos = 1
        do i = 1 , numpar - 1
          do while ( string( ipos:ipos ) == ' ' )
            ipos = ipos + 1
          end do
          do while ( string( ipos:ipos ) /= ' ' )
            ipos = ipos + 1
          end do
        end do
        do while ( string( ipos:ipos ) == ' ' )
          ipos = ipos + 1
        end do
        iend = ipos + index( string( ipos: ) , ' ' ) - 1
        param = string( ipos:iend )
      end if
!
      return
      end
        SUBROUTINE upcase ( s, n )
!
!*******************************************************************************
!                                                                              *
!     Revision : 1.0           Author : J.Jansen     Date : 29 April 1996      *
!                                                                              *
!------------------------------------------------------------------------------*
!                                                                              *
!* upcase ( s ) - converts first n lower case char's in s to uppercase         *
!                                                                              *
! VMS(VAX,AXP)/AIX(RS6000)/ULTRIX version                                      *
!                                                                              *
!*******************************************************************************
!
        INTEGER*4       shift
        PARAMETER     ( shift = -32 )  !  a - A
!
        CHARACTER*(*)   s
        CHARACTER*1     c
        INTEGER*4       n, l, i
!
        l = min ( n, len ( s ) )
        DO i = 1, l
          c = s ( i:i )
          IF ( ( c .GE. 'a' ) .AND. ( c .LE. 'z' ) ) &
                         s ( i:i ) = char ( ichar ( c ) + shift )
        END DO
        END
